####################################
#
# Solution for stage G
#
class Cell:
    def __init__(self,x,y):
        self.x = x
        self.y = y
        self.state = 0 #empty
        self.mysub = 0
    def SetSub(self,sub):
        self.state = 1 #sub
        self.mysub = sub
    def Hit(self):
        if self.state == 0:
            self.state = 2 #miss
            return 0
        elif self.state == 1: #if cell has a not-hit-yet sub
            self.state = 3 #hit
            self.mysub.Hit()
            return 1
    def IsHit(self):
        return self.state == 3
    def IsAdjacent(self,c):
        return  ( abs(self.x - c.x) == 1 and (self.y == c.y) ) or ( abs(self.y - c.y) == 1 \
                                                                    and (self.x == c.x) )
    def ToString(self,is_private=1):
        if self.state == 0: # empty
            return "."
        elif self.state == 1: # sub
            if is_private:
                return "0"
            else:
                return "."
        elif self.state == 2: # miss
            return "*"
        elif self.state == 3: # hit
            return "@"
        elif self.state == 4: # dead
            return "#"
#
####################################
